﻿/**
*/
module nemuxi.gui.window.dialog.settingdialog.settingif;

debug import std.stdio: wl = writefln, pl = printf;
debug(settingif) void main() {}

public import etc.kareki.kareki;

public import nemuxi.file.items.item;
public import nemuxi.file.items.items;
public import nemuxi.system.text;
public import nemuxi.system.nemuxierrors;
public import nemuxi.negui.keyboard.accelerator;
import nemuxi.negui.event;


interface ISettingInFrame {
	/+
	void setItemList(Item[]);
	Item[] getItemList();
	+/

	/+
	/**
	History:
		1.00β15:
			新規作成
	*/
	Kareha itemTree();
	/**
	History:
		1.00β15:
			新規作成
	*/
	void itemTree(Kareha);
	+/
	/**
	History:
		1.00β15:
			新規作成
	*/
	ItemIconPairs iiPairs();
	/**
	History:
		1.00β15:
			新規作成
	*/
	void iiPairs(ItemIconPairs);

	void show();
	void hide();
	void toChild();
	void reSize(int x, int y, int widh, int height);

	/**
	History:
		1.00β15:
			新規追加。
	*/
	Accelerator accelerator();
	/**
	内部ウィンドウ用アクセラレータ送信。
	
	History:
		1.00β15:
			新規追加。
	*/
	bool toAccelerator(COMMAND_ID Id);

	AkiDocument akiDocument();

}

template MixInSettingInFrame() {
	override {
		void show() {
			setShow(SHOW.SHOWNORMAL);
		}
		void hide() {
			setShow(SHOW.HIDE);
		}
		void toChild() {
			super.toChild();
		}
		void reSize(int x, int y, int width, int height) {
			move(x, y, width, height);
		}
		/**
		History:
			1.00β12:
				新規追加。
		*/
		protected void OnEnable(bool Enable) {
			parent.enable = Enable;
		}

		/**
		History:
			1.00β15:
				ISettingInFrame.acceleratorに合わせて新規追加。
		*/
		Accelerator accelerator() {
			return super.accelerator;
		}
	}
	/**
	History:
		1.00β15:
			ISettingInFrame.toAcceleratorに合わせて新規追加。
	*/
	bool toAccelerator(COMMAND_ID Id) {
		return OnAccelerator(Id);
	}
	debug bool One=true;
	private void AcceleratorClear() {
		debug {
			assert(One);
			One=false;
		}
		super.accelerator = null;
		delete AccelObject;
	}
}

